from fabric.api import local
from fabric.context_managers import prefix


def virtualenv(func):
    def wrapped(*args, **kwargs):
        with prefix('. .env/bin/activate'):
            return func(*args, **kwargs)
    return wrapped


def bootstrap():
    local('virtualenv -p /usr/bin/python2 .env')
    local('.env/bin/pip install -r requirements.txt')


@virtualenv
def manage(*args, **kwargs):
    cmd = ['python locolander/manage.py']
    cmd.extend(args)
    cmd.extend("%s=%s" % (key, value) for key, value in kwargs.items())
    local(' '.join(cmd))


@virtualenv
def run():
    manage('supervisor')


@virtualenv
def test():
    local('./run_tests.sh')


@virtualenv
def docker_build():
    local('python ns2df.py locolander .locolander.yml Dockerfile')
    local('docker build -t locolander .')
